🚨🚨🚨

Cucumber is publishing new releases under `@cucumber/cucumber` on npm:  
<https://www.npmjs.com/package/@cucumber/cucumber>

Features in the latest version include:
- `BeforeEach` and `AfterEach` hooks
- Searchable HTML reports
- Native ESM support
- Write scenarios in Markdown

Full changelog: https://github.com/cucumber/cucumber-js/blob/main/CHANGELOG.md  
Upgrading guide: https://github.com/cucumber/cucumber-js/blob/main/UPGRADING.md

🚨🚨🚨

# Cucumber

[Cucumber](https://cucumber.io) is a tool for running automated tests written in plain language. Because they're
written in plain language, they can be read by anyone on your team. Because they can be
read by anyone, you can use them to help improve communication, collaboration and trust on
your team.

Cucumber.js is the JavaScript implementation of Cucumber and runs on the [maintained Node.js versions](https://github.com/nodejs/Release) and *modern* web browsers.

## Help & support

* See here: https://cucumber.io/support

## Contributing

See [CONTRIBUTING.md](CONTRIBUTING.md) for info on contributing to Cucumber.js.

## Code of Conduct

Everyone interacting in this codebase and issue tracker is expected to follow the Cucumber [code of conduct](https://github.com/cucumber/cucumber/blob/master/CODE_OF_CONDUCT.md).

## Install

[![npm downloads](https://img.shields.io/npm/dm/cucumber.svg?style=flat-square)](http://npm-stat.com/charts.html?package=cucumber&from=2015-09-01)


### Node

Cucumber.js is available as an npm module.

``` shell
$ npm install cucumber
```

### Browser

* Grab the browserified code from the latest release in the [dist](/dist) folder

## Documentation

The following documentation is for master. See below for documentation for older versions. 

* [CLI](/docs/cli.md)
* [Custom Formatters](/docs/custom_formatters.md)
* [Custom Snippet Syntaxes](/docs/custom_snippet_syntaxes.md)
* [NodeJs Example](/docs/nodejs_example.md)
* Support Files
  * [World](/docs/support_files/world.md)
  * [Step Definitions](/docs/support_files/step_definitions.md)
  * [Hooks](/docs/support_files/hooks.md)
  * [Timeouts](docs/support_files/timeouts.md)
  * [Data Table Interface](/docs/support_files/data_table_interface.md)
  * [Attachments](/docs/support_files/attachments.md)
  * [API Reference](/docs/support_files/api_reference.md)
* [FAQ](/docs/faq.md)

#### Documentation for older versions

* [`5.x`](https://github.com/cucumber/cucumber-js/tree/5.x)
* [`4.x`](https://github.com/cucumber/cucumber-js/tree/4.x)
* [`3.x`](https://github.com/cucumber/cucumber-js/tree/3.x)
* [`2.x`](https://github.com/cucumber/cucumber-js/tree/2.x)
* [`1.x`](https://github.com/cucumber/cucumber-js/tree/1.x)
